Loading...
Searching...
No Matches
allocator_traits< rheolef::heap_allocator< T > >

## Detailed Description

template<class T>
struct std::allocator_traits< rheolef::heap_allocator< T > >

Definition at line 239 of file heap_allocator.h.

## Public Types

using | allocator_type = rheolef::heap_allocator< T >
using | value_type = T
using | pointer = T *
using | const_pointer = typename std::pointer_traits< pointer >::rebind< const value_type >
using | void_pointer = typename std::pointer_traits< pointer >::rebind< void >
using | const_void_pointer = typename std::pointer_traits< pointer >::rebind< const void >
using | difference_type = typename std::pointer_traits< pointer >::difference_type
using | size_type = typename std::make_unsigned< difference_type >::type
using | propagate_on_container_copy_assignment = std::false_type
using | propagate_on_container_move_assignment = std::false_type
using | propagate_on_container_swap = std::false_type
using | is_always_equal = typename std::is_empty< rheolef::heap_allocator< T > >::type
template<class U >
using | rebind_alloc = rheolef::heap_allocator< U >

## Static Public Member Functions

static pointer | allocate (allocator_type &a, size_type n)
static void | deallocate (allocator_type &a, pointer p, size_type n)
static void | construct (allocator_type &a, pointer p)
static void | construct (allocator_type &a, pointer p, const T &c)
template<class U >
static void | destroy (allocator_type &a, U *p)
static size_type | max_size (const allocator_type &a)

## Member Typedef Documentation

## allocator_type

template<class T >

using allocator_type = rheolef::heap_allocator<T>

Definition at line 242 of file heap_allocator.h.

## value_type

template<class T >

using value_type = T

Definition at line 243 of file heap_allocator.h.

## pointer

template<class T >

using pointer = T*

Definition at line 244 of file heap_allocator.h.

## const_pointer

template<class T >

using const_pointer = typename std::pointer_traits<pointer>::rebind<const value_type>

Definition at line 245 of file heap_allocator.h.

## void_pointer

template<class T >

using void_pointer = typename std::pointer_traits<pointer>::rebind<void>

Definition at line 246 of file heap_allocator.h.

## const_void_pointer

template<class T >

using const_void_pointer = typename std::pointer_traits<pointer>::rebind<const void>

Definition at line 247 of file heap_allocator.h.

## difference_type

template<class T >

using difference_type = typename std::pointer_traits<pointer>::difference_type

Definition at line 248 of file heap_allocator.h.

## size_type

template<class T >

using size_type = typename std::make_unsigned<difference_type>::type

Definition at line 249 of file heap_allocator.h.

## propagate_on_container_copy_assignment

template<class T >

using propagate_on_container_copy_assignment = std::false_type

Definition at line 250 of file heap_allocator.h.

## propagate_on_container_move_assignment

template<class T >

using propagate_on_container_move_assignment = std::false_type

Definition at line 251 of file heap_allocator.h.

## propagate_on_container_swap

template<class T >

using propagate_on_container_swap = std::false_type

Definition at line 252 of file heap_allocator.h.

## is_always_equal

template<class T >

using is_always_equal = typename std::is_empty<rheolef::heap_allocator<T> >::type

Definition at line 253 of file heap_allocator.h.

## rebind_alloc

template<class T >
template<class U >

using rebind_alloc = rheolef::heap_allocator<U>

Definition at line 255 of file heap_allocator.h.

## Member Function Documentation

## allocate()

template<class T >

static pointer allocate | ( | allocator_type & | a,
|  | size_type | n
| ) |  |

static

Definition at line 259 of file heap_allocator.h.

## deallocate()

template<class T >

static void deallocate | ( | allocator_type & | a,
|  | pointer | p,
|  | size_type | n
| ) |  |

static

Definition at line 260 of file heap_allocator.h.

## construct() [1/2]

template<class T >

static void construct | ( | allocator_type & | a,
|  | pointer | p
| ) |  |

static

Definition at line 261 of file heap_allocator.h.

## construct() [2/2]

template<class T >

static void construct | ( | allocator_type & | a,
|  | pointer | p,
|  | const T & | c
| ) |  |

static

Definition at line 262 of file heap_allocator.h.

## destroy()

template<class T >
template<class U >

static void destroy | ( | allocator_type & | a,
|  | U * | p
| ) |  |

static

Definition at line 264 of file heap_allocator.h.

## max_size()

template<class T >

static size_type max_size | ( | const allocator_type & | a | ) |

static

Definition at line 265 of file heap_allocator.h.

The documentation for this struct was generated from the following file:

- /build/rheolef-Hrneba/rheolef-7.2/util/lib/heap_allocator.h